/*
 * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
 * Copyright (C) 2008 Alp Toker <alp@atoker.com>
 * Copyright (C) 2008 Apple Inc.
 */
#ifndef __GdomCharacterData_H__
#define __GdomCharacterData_H__
#include <webkit/webkitdefines.h>
#include "gdom/GdomEventTargetNode.h"
#include "glib-object.h"


G_BEGIN_DECLS

typedef struct _GdomCharacterData GdomCharacterData;
typedef struct _GdomCharacterDataClass GdomCharacterDataClass;


#define GDOM_TYPE_CHARACTER_DATA            (gdom_character_data_get_type())
#define GDOM_CHARACTER_DATA(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_CHARACTER_DATA, GdomCharacterData))
#define GDOM_CHARACTER_DATA_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_CHARACTER_DATA, GdomCharacterData)Class)
#define GDOM_IS_CHARACTER_DATA(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_CHARACTER_DATA))
#define GDOM_IS_CHARACTER_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_CHARACTER_DATA))
#define GDOM_CHARACTER_DATA_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_CHARACTER_DATA, GdomCharacterDataClass))

typedef struct _GdomCharacterDataPrivate GdomCharacterDataPrivate;

struct _GdomCharacterData {
    GdomEventTargetNode parent_instance;
    GdomCharacterDataPrivate *priv;
};

struct _GdomCharacterDataClass {
    GObjectClass parent_class;
};

WEBKIT_API GType
gdom_character_data_get_type (void);

WEBKIT_API gchar *
gdom_character_data_substring_data (GdomCharacterData *thiz, gulong offset, gulong length);

WEBKIT_API void
gdom_character_data_append_data (GdomCharacterData *thiz, gchar * data);

WEBKIT_API void
gdom_character_data_insert_data (GdomCharacterData *thiz, gulong offset, gchar * data);

WEBKIT_API void
gdom_character_data_delete_data (GdomCharacterData *thiz, gulong offset, gulong length);

WEBKIT_API void
gdom_character_data_replace_data (GdomCharacterData *thiz, gulong offset, gulong length, gchar * data);

G_END_DECLS

#endif /* __GdomCharacterData_H__ */
